---
title: Save Completed Forms to PDF
product: PDF Generator
description: See how to save a completed form as a PDF file using the SurveyJS PDF Generator library in your JavaScript app. You can archive your PDF forms in original format and easily access or share them once needed.
framework: Vanilla JS
source: https://surveyjs.io/pdf-generator/examples/save-completed-forms-as-pdf-files/vanillajs
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Save Completed Forms to PDF (Vanilla JS)

SurveyJS PDF Generator is a client-side extension over SurveyJS Form Library that enables users to save surveys as PDF documents. This example shows how to save a filled-out form as a PDF document.

Start with creating a [`SurveyPDF`](/pdf-generator/documentation/api-reference/surveypdf) instance. A `SurveyPDF` constructor accepts a survey JSON schema and [PDF document configuration options](/pdf-generator/documentation/api-reference/idocoptions) as parameters:

```js
const surveyPdf = new SurveyPDF.SurveyPDF(surveyJson, pdfDocOptions);

// In modular applications:
import { SurveyPDF } from "survey-pdf";
const surveyPdf = new SurveyPDF(surveyJson, pdfDocOptions);
```

To generate a PDF document with given answers, assign a JSON object with survey results to `SurveyPDF`'s `data` property. Call the [`save(fileName)`](/pdf-generator/documentation/api-reference/surveypdf#save) method to save the generated form on the user's computer:

```js
surveyPdf.data = surveyResults;
surveyPdf.save("My Survey.pdf");
```

## Files

### `public/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;"></div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import { SurveyPDF } from "survey-pdf";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function createSurveyPdfModel (surveyModel) {
    const options = {
        otherRowsCount: 1
    };
    const surveyPDF = new SurveyPDF(json, options);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    surveyPDF.onGetPanelStyle.add((_, options) => {
        const compactPanels = [
            "medical-plan-panel",
            "dental-plan-panel",
            "forth-panel",
            "vision-plan-panel"
        ];

        if (compactPanels.includes(options.panel.name)) {
            options.style.minWidth = 0;
        }
    });

    surveyPDF.onGetQuestionStyle.add((_, options) => {
        if (
            options.question.name === "sex" ||
            options.question.name === "persons-covered"
        ) {
            options.style.columnMinWidth = 20;
        }
    });
    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

const survey = new Model(json);
survey.showCompleteButton = false;
survey.navigationButtonsLocation = "topBottom";
survey.addNavigationItem({
    id: "survey_save_as_file",
    title: "Download PDF",
    action: () => {
        saveSurveyToPdf("surveyResult.pdf", survey);
    }
});
survey.addNavigationItem({
    id: "survey_pdf_preview",
    title: "Preview PDF",
    visible: window.navigator.pdfViewerEnabled,
    action: () => {
        previewPdf(survey);
    }
});
survey.data = {
  "name": "Jane Doe",
  "ssn": "123-45-6789",
  "address": "742 Evergreen Terrace",
  "dob": "1985-03-15",
  "city": "Springfield",
  "state": "IL",
  "zip-code": "62704",
  "phone-number": "217 555-0142",
  "email": "jane.doe@example.com",
  "sex": "Female",
  "marital-status": "married",
  "date-of-marriage": "2012-06-08",
  "employer": "Acme Corporation",
  "job-title": "Senior Analyst",
  "date-of-hire": "2018-09-04",
  "other-insurance": true,
  "who-through": "spouse",
  "date-of-coverage": "2024-01-01",
  "carrier": "Blue Cross Blue Shield",
  "policy-number": "BC-8847291",
  "are-you-covered-by-medicare": false,
  "spouse-dependents-medicare": false,
  "persons-covered": {
     "employer": {
        "coverage": [
           "add"
        ],
        "first-name": "Jane",
        "surname": "Doe",
        "date-of-birth": "1985-03-15",
        "ssn": "123-45-6789",
        "sex": "female"
     },
     "spouse": {
        "coverage": [
           "add"
        ],
        "first-name": "John",
        "surname": "Doe",
        "date-of-birth": "1983-11-22",
        "ssn": "987-65-4321",
        "sex": "male"
     },
     "chd1": {
        "coverage": [
           "add"
        ],
        "first-name": "Emily",
        "surname": "Doe",
        "date-of-birth": "2015-04-10",
        "ssn": "456-78-9012",
        "sex": "female"
     }
  },
  "medical-multi": {
     "carrier": "CareFirst",
     "plan-type": "PPO",
     "carrier-group": "GRP-10294"
  },
  "medical-plan-coverage": [
     "fam"
  ],
  "dental-multi": {
     "carrier": "Delta Dental",
     "plan-type": "Premium",
     "carrier-group": "DD-55821"
  },
  "dental-plan-coverage": [
     "fam"
  ],
  "dental-plan-details": {
     "carrier": "DL-9021",
     "plan-type": "Dr. Sarah Mitchell",
     "carrier-group": "Yes",
     "name": "Dr. Sarah Mitchell",
     "office": "Springfield Family Dental"
  },
  "vision-plan-multi": {
     "carrier": "VSP",
     "carrier-group": "VSP-44102"
  },
  "vision-plan-coverage": [
     "fam"
  ],
  "vision-plan-options": [
     "Item 1"
  ],
  "vision-plan-details": {
     "carrier": "MetLife",
     "benefit": "250"
  },
  "options": [
     "emp-only"
  ],
  "vol-life": [
     "Item 1"
  ],
  "vol-life-Comment": "100000",
  "spouse": [
     "Item 1"
  ],
  "spouse-Comment": "50000",
  "dependent-child": [
     "Item 1"
  ],
  "dependent-child-Comment": "10000",
  "carrier-forth-panel": {
     "carrier": "Guardian"
  },
  "forth-panel-options": [
     "Item 1"
  ],
  "forth-panel-multi": {
     "carrier": "Guardian",
     "plan": "STD-204",
     "benefit": "1200"
  },
  "emp-signature-date": "2026-05-27",
  "hr-approval-date": "2026-05-28"
}
survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "title": "Employee Health Insurance Enrollment Form",
  "description": "Please note that completing this form does not guarantee coverage.",
  "pages": [
    {
      "name": "employee-health-insurance-enrollment-form",
      "elements": [
        {
          "type": "panel",
          "name": "contact-details-panel",
          "title": "Contact Details",
          "elements": [
            {
              "type": "text",
              "name": "name",
              "title": "Name"
            },
            {
              "type": "text",
              "name": "ssn",
              "startWithNewLine": false,
              "title": "SSN",
              "width": "30%",
              "maskType": "pattern",
              "maskSettings": {
                "pattern": "999-99-9999"
              }
            },
            {
              "type": "text",
              "name": "address",
              "title": "Address"
            },
            {
              "type": "text",
              "name": "dob",
              "width": "30%",
              "startWithNewLine": false,
              "title": "Date of Birth",
              "inputType": "date",
              "maskType": "datetime",
              "maskSettings": {
                "pattern": "mm/dd/yyyy"
              }
            },
            {
              "type": "text",
              "name": "city",
              "title": "City"
            },
            {
              "type": "text",
              "name": "state",
              "startWithNewLine": false,
              "title": "State"
            },
            {
              "type": "text",
              "name": "zip-code",
              "startWithNewLine": false,
              "title": "Zip Code",
              "width": "30%",
              "maskType": "pattern",
              "maskSettings": {
                "pattern": "99999"
              }
            },
            {
              "type": "text",
              "name": "phone-number",
              "title": "Phone Number",
              "maskType": "pattern",
              "maskSettings": {
                "pattern": "999 999-9999"
              }
            },
            {
              "type": "text",
              "name": "email",
              "startWithNewLine": false,
              "title": "E-Mail ",
              "inputType": "email",
              "placeholder": "name@example.com"
            },
            {
              "type": "radiogroup",
              "name": "sex",
              "width": "30%",
              "startWithNewLine": false,
              "title": "Sex",
              "choices": [
                {
                  "value": "male",
                  "text": "Male"
                },
                "Female"
              ],
              "colCount": 2
            },
            {
              "type": "dropdown",
              "name": "marital-status",
              "title": "Marital Status",
              "choices": [
                {
                  "value": "single",
                  "text": "Single"
                },
                {
                  "value": "married",
                  "text": "Married"
                },
                {
                  "value": "divorced",
                  "text": "Divorced"
                },
                {
                  "value": "separated",
                  "text": "Separated"
                },
                {
                  "value": "widowed",
                  "text": "Widowed"
                }
              ]
            },
            {
              "type": "text",
              "name": "date-of-marriage",
              "startWithNewLine": false,
              "title": "Date of Marriage",
              "description": "Only if 'Married' is selected.",
              "descriptionLocation": "underInput",
              "inputType": "date",
              "maskType": "datetime",
              "maskSettings": {
                "pattern": "mm/dd/yyyy"
              }
            }
          ]
        },
        {
          "type": "panel",
          "name": "work-details",
          "title": "Work Information",
          "elements": [
            {
              "type": "text",
              "name": "employer",
              "title": "Employer"
            },
            {
              "type": "text",
              "name": "job-title",
              "startWithNewLine": false,
              "title": "Job Title"
            },
            {
              "type": "text",
              "name": "date-of-hire",
              "width": "30%",
              "startWithNewLine": false,
              "title": "Date of Hire",
              "inputType": "date"
            }
          ]
        },
        {
          "type": "panel",
          "name": "other-insurance-panel",
          "title": "Other Insurance Information",
          "elements": [
            {
              "type": "boolean",
              "name": "other-insurance",
              "title": "Does anyone in your family have other insurance?",
              "descriptionLocation": "underInput"
            },
            {
              "type": "dropdown",
              "name": "who-through",
              "startWithNewLine": false,
              "title": "If yes, who is the coverage through?",
              "choices": [
                {
                  "value": "self",
                  "text": "Self"
                },
                {
                  "value": "spouse",
                  "text": "Spouse"
                },
                {
                  "value": "parent",
                  "text": "Parent"
                }
              ]
            },
            {
              "type": "text",
              "width": "30%",
              "name": "date-of-coverage",
              "startWithNewLine": false,
              "title": "Effective Date of Coverage:",
              "inputType": "date"
            },
            {
              "type": "text",
              "name": "carrier",
              "title": "Carrier:"
            },
            {
              "type": "text",
              "name": "policy-number",
              "startWithNewLine": false,
              "title": "Policy #: "
            },
            {
              "type": "boolean",
              "name": "are-you-covered-by-medicare",
              "title": "Are you covered by Medicare?"
            },
            {
              "type": "text",
              "name": "medicate-number",
              "startWithNewLine": false,
              "title": "Medicare #"
            },
            {
              "type": "text",
              "name": "medicare-date-part-A",
              "title": "Effective Date (Part A):",
              "inputType": "date"
            },
            {
              "type": "text",
              "name": "medicate-date-part-B",
              "startWithNewLine": false,
              "title": "Effective Date (Part B):",
              "inputType": "date"
            },
            {
              "type": "boolean",
              "name": "spouse-dependents-medicare",
              "title": "Is your spouse or dependent(s) covered by Medicare?"
            },
            {
              "type": "text",
              "name": "medicare-spouse",
              "startWithNewLine": false,
              "title": "Medicare #"
            },
            {
              "type": "text",
              "name": "medicare-dependents-date-part-A",
              "title": "Effective Date (Part A):",
              "inputType": "date"
            },
            {
              "type": "text",
              "name": "medicare-dependents-date-part-B",
              "startWithNewLine": false,
              "title": "Effective Date (Part B):",
              "inputType": "date"
            }
          ]
        },
        {
          "type": "panel",
          "name": "health-insurance-panel",
          "title": "Persons Covered ",
          "description": "Only your Legal Spouse and unmarried natural, adopted or stepchildren who meet the dependent requirements are eligible for coverage.",
          "elements": [
            {
              "type": "matrixdropdown",
              "name": "persons-covered",
              "title": "Persons Covered: ",
              "titleLocation": "hidden",
              "description": "Only your Legal Spouse and unmarried natural, adopted or stepchildren who meet the dependent requirements are eligible for coverage.",
              "alternateRows": true,
              "columns": [
                {
                  "name": "coverage",
                  "title": "Coverage",
                  "cellType": "checkbox",
                  "minWidth": "110px",
                  "choices": [
                    {
                      "value": "add",
                      "text": "Add"
                    },
                    {
                      "value": "remove",
                      "text": "Remove"
                    }
                  ]
                },
                {
                  "name": "first-name",
                  "title": "First Name",
                  "cellType": "text"
                },
                {
                  "name": "surname",
                  "title": "Surname",
                  "cellType": "text"
                },
                {
                  "name": "date-of-birth",
                  "title": "Date of Birth",
                  "cellType": "text",
                  "minWidth": "110px",
                  "inputType": "date"
                },
                {
                  "name": "ssn",
                  "title": "SSN",
                  "cellType": "text",
                  "maskType": "pattern",
                  "maskSettings": {
                    "pattern": "999-99-9999"
                  }
                },
                {
                  "name": "sex",
                  "title": "Sex",
                  "cellType": "dropdown",
                  "choices": [
                    {
                      "value": "male",
                      "text": "Male"
                    },
                    {
                      "value": "female",
                      "text": "Female"
                    }
                  ]
                }
              ],
              "choices": [
                1,
                2,
                3,
                4,
                5
              ],
              "rows": [
                {
                  "value": "employer",
                  "text": "Employer"
                },
                {
                  "value": "spouse",
                  "text": "Spouse"
                },
                {
                  "value": "chd1",
                  "text": "Child #1"
                },
                {
                  "value": "chd2",
                  "text": "Child #2"
                },
                {
                  "value": "chd3",
                  "text": "Child #3"
                },
                {
                  "value": "chd4",
                  "text": "Child #4"
                },
                {
                  "value": "chd5",
                  "text": "Child #5"
                },
                {
                  "value": "chd6",
                  "text": "Child #6"
                }
              ],
              "rowTitleWidth": "90px"
            }
          ]
        },
        {
          "type": "panel",
          "name": "medical-plan-panel",
          "title": "Medical Plan",
          "elements": [
            {
              "type": "multipletext",
              "name": "medical-multi",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                },
                {
                  "name": "plan-type",
                  "title": "Plan Type"
                },
                {
                  "name": "carrier-group",
                  "title": "Carrier Group #"
                }
              ],
              "itemTitleWidth": "120px"
            },
            {
              "type": "checkbox",
              "name": "medical-plan-coverage",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "emp-only",
                  "text": "Employee Only"
                },
                {
                  "value": "emp-sps",
                  "text": "Employee & Spouse"
                },
                {
                  "value": "emp-chl",
                  "text": "Employee / Child(ren)"
                },
                {
                  "value": "fam",
                  "text": "Family"
                },
                {
                  "value": "over-sixty-five",
                  "text": "Over 65",
                  "isCommentRequired": true,
                  "commentPlaceholder": "retired/working"
                },
                {
                  "value": "med-comp",
                  "text": "Medicare or Complimentary to Medicare (CareFirst-Individual only; and benefit coverage only. Not eligible for HSA)"
                },
                {
                  "value": "waive-coverage",
                  "text": "Waive Coverage*"
                }
              ]
            }
          ]
        },
        {
          "type": "panel",
          "name": "dental-plan-panel",
          "title": "Dental Plan",
          "startWithNewLine": false,
          "elements": [
            {
              "type": "multipletext",
              "name": "dental-multi",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                },
                {
                  "name": "plan-type",
                  "title": "Plan Type"
                },
                {
                  "name": "carrier-group",
                  "title": "Carrier Group #"
                }
              ],
              "itemTitleWidth": "120px"
            },
            {
              "type": "checkbox",
              "name": "dental-plan-coverage",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "emp-only",
                  "text": "Employee Only"
                },
                {
                  "value": "emp-sps",
                  "text": "Employee & Spouse"
                },
                {
                  "value": "emp-chl",
                  "text": "Employee / Child(ren)"
                },
                {
                  "value": "fam",
                  "text": "Family"
                },
                {
                  "value": "over-sixty-five",
                  "text": "Over 65",
                  "isCommentRequired": true,
                  "commentPlaceholder": "retired/working"
                },
                {
                  "value": "waive-coverage",
                  "text": "Waive Coverage*"
                }
              ]
            },
            {
              "type": "multipletext",
              "name": "dental-plan-details",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Provider # "
                },
                {
                  "name": "plan-type",
                  "title": "Name"
                },
                {
                  "name": "carrier-group",
                  "title": "Family Dentist"
                },
                {
                  "name": "name",
                  "title": "Name"
                },
                {
                  "name": "office",
                  "title": "Office #"
                }
              ],
              "itemTitleWidth": "120px"
            }
          ]
        },
        {
          "type": "panel",
          "name": "vision-plan-panel",
          "title": "Vision Plan",
          "elements": [
            {
              "type": "multipletext",
              "name": "vision-plan-multi",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                },
                {
                  "name": "carrier-group",
                  "title": "Carrier Group #"
                }
              ],
              "itemTitleWidth": "120px"
            },
            {
              "type": "checkbox",
              "name": "vision-plan-coverage",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "emp-only",
                  "text": "Employee Only"
                },
                {
                  "value": "emp-sps",
                  "text": "Employee & Spouse"
                },
                {
                  "value": "emp-chl",
                  "text": "Employee / Child(ren)"
                },
                {
                  "value": "fam",
                  "text": "Family"
                },
                {
                  "value": "over-sixty-five",
                  "text": "Over 65",
                  "isCommentRequired": true,
                  "commentPlaceholder": "retired/working"
                },
                {
                  "value": "waive-coverage",
                  "text": "Waive Coverage*"
                }
              ]
            },
            {
              "type": "checkbox",
              "name": "vision-plan-options",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "Item 1",
                  "text": "LTD (if offered)"
                },
                {
                  "value": "Item 2",
                  "text": "VOL. LTD"
                },
                {
                  "value": "Item 3",
                  "text": "Waive Coverage*"
                },
                {
                  "value": "Item 4",
                  "text": "Waive Coverage*"
                }
              ],
              "colCount": 2
            },
            {
              "type": "multipletext",
              "name": "vision-plan-details",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                },
                {
                  "name": "benefit",
                  "placeholder": "/Mo",
                  "inputTextAlignment": "right",
                  "title": "Benefit $"
                }
              ],
              "itemTitleWidth": "120px"
            }
          ]
        },
        {
          "type": "panel",
          "name": "forth-panel",
          "title": " ",
          "startWithNewLine": false,
          "elements": [
            {
              "type": "checkbox",
              "name": "options",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "emp-only",
                  "text": "LIFE AND AD&D (if offered)"
                },
                {
                  "value": "emp-sps",
                  "text": "Waive Coverage*"
                }
              ]
            },
            {
              "type": "checkbox",
              "name": "vol-life",
              "titleLocation": "hidden",
              "showCommentArea": true,
              "commentText": "",
              "choices": [
                {
                  "value": "Item 1",
                  "text": "VOL LIFE $"
                }
              ]
            },
            {
              "type": "checkbox",
              "name": "spouse",
              "titleLocation": "hidden",
              "showCommentArea": true,
              "commentText": "",
              "choices": [
                {
                  "value": "Item 1",
                  "text": "SPOUSE $"
                }
              ]
            },
            {
              "type": "checkbox",
              "name": "dependent-child",
              "titleLocation": "hidden",
              "showCommentArea": true,
              "commentText": "",
              "choices": [
                {
                  "value": "Item 1",
                  "text": "DEPENDENT CHILD $"
                }
              ]
            },
            {
              "type": "multipletext",
              "name": "carrier-forth-panel",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                }
              ],
              "itemTitleWidth": "120px"
            },
            {
              "type": "checkbox",
              "name": "forth-panel-options",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "Item 1",
                  "text": "STD (if offered)"
                },
                {
                  "value": "Item 2",
                  "text": "VOL. STD"
                },
                {
                  "value": "Item 3",
                  "text": "Waive Coverage*"
                },
                {
                  "value": "Item 4",
                  "text": "Waive Coverage*"
                }
              ],
              "colCount": 2
            },
            {
              "type": "multipletext",
              "name": "forth-panel-multi",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                },
                {
                  "name": "plan",
                  "title": "Plan #"
                },
                {
                  "name": "benefit",
                  "placeholder": "/Mo",
                  "inputTextAlignment": "right",
                  "title": "Benefit $"
                }
              ],
              "itemTitleWidth": "120px"
            }
          ]
        },
        {
          "type": "html",
          "name": "what-the-form-does",
          "html": "<p>\nThis form provides an option to make contributions for health insurance using pre-tax deductions, where applicable. By enrolling in a group health insurance plan, you acknowledge that eligible contributions may be deducted from your pay on a pre-tax basis, in accordance with applicable regulations. Pre-tax contributions may reduce taxable income, depending on individual circumstances. If you prefer not to use pre-tax deductions, please contact your HR representative or plan administrator.\n</p>"
        },
        {
          "type": "html",
          "name": "acknowledgment",
          "html": "<p>\nBy completing this form, you confirm that you have reviewed the available enrollment materials and understand the information provided. You also confirm that the selections made reflect your current choices.\n</p>\n"
        },
        {
          "type": "html",
          "name": "confirm-accuracy",
          "html": "<p>\nTo the best of your knowledge, the information provided in this form is accurate and complete. Providing incorrect or incomplete information may affect eligibility or participation in the selected plan(s).\n</p>"
        },
        {
          "type": "signaturepad",
          "name": "emp-signature",
          "title": "Employee's signature",
          "titleLocation": "top",
          "signatureHeight": 100
        },
        {
          "type": "text",
          "name": "emp-signature-date",
          "startWithNewLine": false,
          "title": "Date",
          "titleLocation": "top",
          "inputType": "date"
        },
        {
          "type": "signaturepad",
          "name": "hr-approval",
          "title": "HR approval",
          "titleLocation": "top",
          "signatureHeight": 100
        },
        {
          "type": "text",
          "name": "hr-approval-date",
          "startWithNewLine": false,
          "title": "Date",
          "titleLocation": "top",
          "inputType": "date"
        }
      ]
    }
  ],
  "headerView": "advanced"
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest",
    "survey-pdf": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/pdf-generator/examples/save-completed-forms-as-pdf-files/angular.md)
- [React](https://surveyjs.io/pdf-generator/examples/save-completed-forms-as-pdf-files/reactjs.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/save-completed-forms-as-pdf-files/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/save-completed-forms-as-pdf-files/jquery.md)


---
title: Save Completed Forms to PDF
product: PDF Generator
description: See how to save a completed form as a PDF file using the SurveyJS PDF Generator library in your JavaScript app. You can archive your PDF forms in original format and easily access or share them once needed.
framework: React
source: https://surveyjs.io/pdf-generator/examples/save-completed-forms-as-pdf-files/reactjs
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Save Completed Forms to PDF (React)

SurveyJS PDF Generator is a client-side extension over SurveyJS Form Library that enables users to save surveys as PDF documents. This example shows how to save a filled-out form as a PDF document.

Start with creating a [`SurveyPDF`](/pdf-generator/documentation/api-reference/surveypdf) instance. A `SurveyPDF` constructor accepts a survey JSON schema and [PDF document configuration options](/pdf-generator/documentation/api-reference/idocoptions) as parameters:

```js
const surveyPdf = new SurveyPDF.SurveyPDF(surveyJson, pdfDocOptions);

// In modular applications:
import { SurveyPDF } from "survey-pdf";
const surveyPdf = new SurveyPDF(surveyJson, pdfDocOptions);
```

To generate a PDF document with given answers, assign a JSON object with survey results to `SurveyPDF`'s `data` property. Call the [`save(fileName)`](/pdf-generator/documentation/api-reference/surveypdf#save) method to save the generated form on the user's computer:

```js
surveyPdf.data = surveyResults;
surveyPdf.save("My Survey.pdf");
```

## Files

### `public/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;"></div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/SurveyPdfComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { SurveyPDF } from "survey-pdf";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function createSurveyPdfModel (surveyModel) {
    const options = {
        otherRowsCount: 1
    };
    const surveyPDF = new SurveyPDF(json, options);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    surveyPDF.onGetPanelStyle.add((_, options) => {
        const compactPanels = [
            "medical-plan-panel",
            "dental-plan-panel",
            "forth-panel",
            "vision-plan-panel"
        ];

        if (compactPanels.includes(options.panel.name)) {
            options.style.minWidth = 0;
        }
    });

    surveyPDF.onGetQuestionStyle.add((_, options) => {
        if (
            options.question.name === "sex" ||
            options.question.name === "persons-covered"
        ) {
            options.style.columnMinWidth = 20;
        }
    });
    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

function SurveyPdfComponent () {
    const survey = new Model(json);
    survey.showCompleteButton = false;
    survey.navigationButtonsLocation = "topBottom";
    survey.addNavigationItem({
        id: "survey_save_as_file",
        title: "Download PDF",
        action: () => {
            saveSurveyToPdf("surveyResult.pdf", survey);
        }
    });
    survey.addNavigationItem({
        id: "survey_pdf_preview",
        title: "Preview PDF",
        visible: window.navigator.pdfViewerEnabled,
        action: () => {
            previewPdf(survey);
        }
    });
    survey.data = {
      "name": "Jane Doe",
      "ssn": "123-45-6789",
      "address": "742 Evergreen Terrace",
      "dob": "1985-03-15",
      "city": "Springfield",
      "state": "IL",
      "zip-code": "62704",
      "phone-number": "217 555-0142",
      "email": "jane.doe@example.com",
      "sex": "Female",
      "marital-status": "married",
      "date-of-marriage": "2012-06-08",
      "employer": "Acme Corporation",
      "job-title": "Senior Analyst",
      "date-of-hire": "2018-09-04",
      "other-insurance": true,
      "who-through": "spouse",
      "date-of-coverage": "2024-01-01",
      "carrier": "Blue Cross Blue Shield",
      "policy-number": "BC-8847291",
      "are-you-covered-by-medicare": false,
      "spouse-dependents-medicare": false,
      "persons-covered": {
         "employer": {
            "coverage": [
               "add"
            ],
            "first-name": "Jane",
            "surname": "Doe",
            "date-of-birth": "1985-03-15",
            "ssn": "123-45-6789",
            "sex": "female"
         },
         "spouse": {
            "coverage": [
               "add"
            ],
            "first-name": "John",
            "surname": "Doe",
            "date-of-birth": "1983-11-22",
            "ssn": "987-65-4321",
            "sex": "male"
         },
         "chd1": {
            "coverage": [
               "add"
            ],
            "first-name": "Emily",
            "surname": "Doe",
            "date-of-birth": "2015-04-10",
            "ssn": "456-78-9012",
            "sex": "female"
         }
      },
      "medical-multi": {
         "carrier": "CareFirst",
         "plan-type": "PPO",
         "carrier-group": "GRP-10294"
      },
      "medical-plan-coverage": [
         "fam"
      ],
      "dental-multi": {
         "carrier": "Delta Dental",
         "plan-type": "Premium",
         "carrier-group": "DD-55821"
      },
      "dental-plan-coverage": [
         "fam"
      ],
      "dental-plan-details": {
         "carrier": "DL-9021",
         "plan-type": "Dr. Sarah Mitchell",
         "carrier-group": "Yes",
         "name": "Dr. Sarah Mitchell",
         "office": "Springfield Family Dental"
      },
      "vision-plan-multi": {
         "carrier": "VSP",
         "carrier-group": "VSP-44102"
      },
      "vision-plan-coverage": [
         "fam"
      ],
      "vision-plan-options": [
         "Item 1"
      ],
      "vision-plan-details": {
         "carrier": "MetLife",
         "benefit": "250"
      },
      "options": [
         "emp-only"
      ],
      "vol-life": [
         "Item 1"
      ],
      "vol-life-Comment": "100000",
      "spouse": [
         "Item 1"
      ],
      "spouse-Comment": "50000",
      "dependent-child": [
         "Item 1"
      ],
      "dependent-child-Comment": "10000",
      "carrier-forth-panel": {
         "carrier": "Guardian"
      },
      "forth-panel-options": [
         "Item 1"
      ],
      "forth-panel-multi": {
         "carrier": "Guardian",
         "plan": "STD-204",
         "benefit": "1200"
      },
      "emp-signature-date": "2026-05-27",
      "hr-approval-date": "2026-05-28"
    }
    return (<Survey model={survey} />);
}

export default SurveyPdfComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyPdfComponent from "./SurveyPdfComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyPdfComponent />);
```

### `src/json.js`

```js
export const json = {
  "title": "Employee Health Insurance Enrollment Form",
  "description": "Please note that completing this form does not guarantee coverage.",
  "pages": [
    {
      "name": "employee-health-insurance-enrollment-form",
      "elements": [
        {
          "type": "panel",
          "name": "contact-details-panel",
          "title": "Contact Details",
          "elements": [
            {
              "type": "text",
              "name": "name",
              "title": "Name"
            },
            {
              "type": "text",
              "name": "ssn",
              "startWithNewLine": false,
              "title": "SSN",
              "width": "30%",
              "maskType": "pattern",
              "maskSettings": {
                "pattern": "999-99-9999"
              }
            },
            {
              "type": "text",
              "name": "address",
              "title": "Address"
            },
            {
              "type": "text",
              "name": "dob",
              "width": "30%",
              "startWithNewLine": false,
              "title": "Date of Birth",
              "inputType": "date",
              "maskType": "datetime",
              "maskSettings": {
                "pattern": "mm/dd/yyyy"
              }
            },
            {
              "type": "text",
              "name": "city",
              "title": "City"
            },
            {
              "type": "text",
              "name": "state",
              "startWithNewLine": false,
              "title": "State"
            },
            {
              "type": "text",
              "name": "zip-code",
              "startWithNewLine": false,
              "title": "Zip Code",
              "width": "30%",
              "maskType": "pattern",
              "maskSettings": {
                "pattern": "99999"
              }
            },
            {
              "type": "text",
              "name": "phone-number",
              "title": "Phone Number",
              "maskType": "pattern",
              "maskSettings": {
                "pattern": "999 999-9999"
              }
            },
            {
              "type": "text",
              "name": "email",
              "startWithNewLine": false,
              "title": "E-Mail ",
              "inputType": "email",
              "placeholder": "name@example.com"
            },
            {
              "type": "radiogroup",
              "name": "sex",
              "width": "30%",
              "startWithNewLine": false,
              "title": "Sex",
              "choices": [
                {
                  "value": "male",
                  "text": "Male"
                },
                "Female"
              ],
              "colCount": 2
            },
            {
              "type": "dropdown",
              "name": "marital-status",
              "title": "Marital Status",
              "choices": [
                {
                  "value": "single",
                  "text": "Single"
                },
                {
                  "value": "married",
                  "text": "Married"
                },
                {
                  "value": "divorced",
                  "text": "Divorced"
                },
                {
                  "value": "separated",
                  "text": "Separated"
                },
                {
                  "value": "widowed",
                  "text": "Widowed"
                }
              ]
            },
            {
              "type": "text",
              "name": "date-of-marriage",
              "startWithNewLine": false,
              "title": "Date of Marriage",
              "description": "Only if 'Married' is selected.",
              "descriptionLocation": "underInput",
              "inputType": "date",
              "maskType": "datetime",
              "maskSettings": {
                "pattern": "mm/dd/yyyy"
              }
            }
          ]
        },
        {
          "type": "panel",
          "name": "work-details",
          "title": "Work Information",
          "elements": [
            {
              "type": "text",
              "name": "employer",
              "title": "Employer"
            },
            {
              "type": "text",
              "name": "job-title",
              "startWithNewLine": false,
              "title": "Job Title"
            },
            {
              "type": "text",
              "name": "date-of-hire",
              "width": "30%",
              "startWithNewLine": false,
              "title": "Date of Hire",
              "inputType": "date"
            }
          ]
        },
        {
          "type": "panel",
          "name": "other-insurance-panel",
          "title": "Other Insurance Information",
          "elements": [
            {
              "type": "boolean",
              "name": "other-insurance",
              "title": "Does anyone in your family have other insurance?",
              "descriptionLocation": "underInput"
            },
            {
              "type": "dropdown",
              "name": "who-through",
              "startWithNewLine": false,
              "title": "If yes, who is the coverage through?",
              "choices": [
                {
                  "value": "self",
                  "text": "Self"
                },
                {
                  "value": "spouse",
                  "text": "Spouse"
                },
                {
                  "value": "parent",
                  "text": "Parent"
                }
              ]
            },
            {
              "type": "text",
              "width": "30%",
              "name": "date-of-coverage",
              "startWithNewLine": false,
              "title": "Effective Date of Coverage:",
              "inputType": "date"
            },
            {
              "type": "text",
              "name": "carrier",
              "title": "Carrier:"
            },
            {
              "type": "text",
              "name": "policy-number",
              "startWithNewLine": false,
              "title": "Policy #: "
            },
            {
              "type": "boolean",
              "name": "are-you-covered-by-medicare",
              "title": "Are you covered by Medicare?"
            },
            {
              "type": "text",
              "name": "medicate-number",
              "startWithNewLine": false,
              "title": "Medicare #"
            },
            {
              "type": "text",
              "name": "medicare-date-part-A",
              "title": "Effective Date (Part A):",
              "inputType": "date"
            },
            {
              "type": "text",
              "name": "medicate-date-part-B",
              "startWithNewLine": false,
              "title": "Effective Date (Part B):",
              "inputType": "date"
            },
            {
              "type": "boolean",
              "name": "spouse-dependents-medicare",
              "title": "Is your spouse or dependent(s) covered by Medicare?"
            },
            {
              "type": "text",
              "name": "medicare-spouse",
              "startWithNewLine": false,
              "title": "Medicare #"
            },
            {
              "type": "text",
              "name": "medicare-dependents-date-part-A",
              "title": "Effective Date (Part A):",
              "inputType": "date"
            },
            {
              "type": "text",
              "name": "medicare-dependents-date-part-B",
              "startWithNewLine": false,
              "title": "Effective Date (Part B):",
              "inputType": "date"
            }
          ]
        },
        {
          "type": "panel",
          "name": "health-insurance-panel",
          "title": "Persons Covered ",
          "description": "Only your Legal Spouse and unmarried natural, adopted or stepchildren who meet the dependent requirements are eligible for coverage.",
          "elements": [
            {
              "type": "matrixdropdown",
              "name": "persons-covered",
              "title": "Persons Covered: ",
              "titleLocation": "hidden",
              "description": "Only your Legal Spouse and unmarried natural, adopted or stepchildren who meet the dependent requirements are eligible for coverage.",
              "alternateRows": true,
              "columns": [
                {
                  "name": "coverage",
                  "title": "Coverage",
                  "cellType": "checkbox",
                  "minWidth": "110px",
                  "choices": [
                    {
                      "value": "add",
                      "text": "Add"
                    },
                    {
                      "value": "remove",
                      "text": "Remove"
                    }
                  ]
                },
                {
                  "name": "first-name",
                  "title": "First Name",
                  "cellType": "text"
                },
                {
                  "name": "surname",
                  "title": "Surname",
                  "cellType": "text"
                },
                {
                  "name": "date-of-birth",
                  "title": "Date of Birth",
                  "cellType": "text",
                  "minWidth": "110px",
                  "inputType": "date"
                },
                {
                  "name": "ssn",
                  "title": "SSN",
                  "cellType": "text",
                  "maskType": "pattern",
                  "maskSettings": {
                    "pattern": "999-99-9999"
                  }
                },
                {
                  "name": "sex",
                  "title": "Sex",
                  "cellType": "dropdown",
                  "choices": [
                    {
                      "value": "male",
                      "text": "Male"
                    },
                    {
                      "value": "female",
                      "text": "Female"
                    }
                  ]
                }
              ],
              "choices": [
                1,
                2,
                3,
                4,
                5
              ],
              "rows": [
                {
                  "value": "employer",
                  "text": "Employer"
                },
                {
                  "value": "spouse",
                  "text": "Spouse"
                },
                {
                  "value": "chd1",
                  "text": "Child #1"
                },
                {
                  "value": "chd2",
                  "text": "Child #2"
                },
                {
                  "value": "chd3",
                  "text": "Child #3"
                },
                {
                  "value": "chd4",
                  "text": "Child #4"
                },
                {
                  "value": "chd5",
                  "text": "Child #5"
                },
                {
                  "value": "chd6",
                  "text": "Child #6"
                }
              ],
              "rowTitleWidth": "90px"
            }
          ]
        },
        {
          "type": "panel",
          "name": "medical-plan-panel",
          "title": "Medical Plan",
          "elements": [
            {
              "type": "multipletext",
              "name": "medical-multi",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                },
                {
                  "name": "plan-type",
                  "title": "Plan Type"
                },
                {
                  "name": "carrier-group",
                  "title": "Carrier Group #"
                }
              ],
              "itemTitleWidth": "120px"
            },
            {
              "type": "checkbox",
              "name": "medical-plan-coverage",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "emp-only",
                  "text": "Employee Only"
                },
                {
                  "value": "emp-sps",
                  "text": "Employee & Spouse"
                },
                {
                  "value": "emp-chl",
                  "text": "Employee / Child(ren)"
                },
                {
                  "value": "fam",
                  "text": "Family"
                },
                {
                  "value": "over-sixty-five",
                  "text": "Over 65",
                  "isCommentRequired": true,
                  "commentPlaceholder": "retired/working"
                },
                {
                  "value": "med-comp",
                  "text": "Medicare or Complimentary to Medicare (CareFirst-Individual only; and benefit coverage only. Not eligible for HSA)"
                },
                {
                  "value": "waive-coverage",
                  "text": "Waive Coverage*"
                }
              ]
            }
          ]
        },
        {
          "type": "panel",
          "name": "dental-plan-panel",
          "title": "Dental Plan",
          "startWithNewLine": false,
          "elements": [
            {
              "type": "multipletext",
              "name": "dental-multi",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                },
                {
                  "name": "plan-type",
                  "title": "Plan Type"
                },
                {
                  "name": "carrier-group",
                  "title": "Carrier Group #"
                }
              ],
              "itemTitleWidth": "120px"
            },
            {
              "type": "checkbox",
              "name": "dental-plan-coverage",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "emp-only",
                  "text": "Employee Only"
                },
                {
                  "value": "emp-sps",
                  "text": "Employee & Spouse"
                },
                {
                  "value": "emp-chl",
                  "text": "Employee / Child(ren)"
                },
                {
                  "value": "fam",
                  "text": "Family"
                },
                {
                  "value": "over-sixty-five",
                  "text": "Over 65",
                  "isCommentRequired": true,
                  "commentPlaceholder": "retired/working"
                },
                {
                  "value": "waive-coverage",
                  "text": "Waive Coverage*"
                }
              ]
            },
            {
              "type": "multipletext",
              "name": "dental-plan-details",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Provider # "
                },
                {
                  "name": "plan-type",
                  "title": "Name"
                },
                {
                  "name": "carrier-group",
                  "title": "Family Dentist"
                },
                {
                  "name": "name",
                  "title": "Name"
                },
                {
                  "name": "office",
                  "title": "Office #"
                }
              ],
              "itemTitleWidth": "120px"
            }
          ]
        },
        {
          "type": "panel",
          "name": "vision-plan-panel",
          "title": "Vision Plan",
          "elements": [
            {
              "type": "multipletext",
              "name": "vision-plan-multi",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                },
                {
                  "name": "carrier-group",
                  "title": "Carrier Group #"
                }
              ],
              "itemTitleWidth": "120px"
            },
            {
              "type": "checkbox",
              "name": "vision-plan-coverage",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "emp-only",
                  "text": "Employee Only"
                },
                {
                  "value": "emp-sps",
                  "text": "Employee & Spouse"
                },
                {
                  "value": "emp-chl",
                  "text": "Employee / Child(ren)"
                },
                {
                  "value": "fam",
                  "text": "Family"
                },
                {
                  "value": "over-sixty-five",
                  "text": "Over 65",
                  "isCommentRequired": true,
                  "commentPlaceholder": "retired/working"
                },
                {
                  "value": "waive-coverage",
                  "text": "Waive Coverage*"
                }
              ]
            },
            {
              "type": "checkbox",
              "name": "vision-plan-options",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "Item 1",
                  "text": "LTD (if offered)"
                },
                {
                  "value": "Item 2",
                  "text": "VOL. LTD"
                },
                {
                  "value": "Item 3",
                  "text": "Waive Coverage*"
                },
                {
                  "value": "Item 4",
                  "text": "Waive Coverage*"
                }
              ],
              "colCount": 2
            },
            {
              "type": "multipletext",
              "name": "vision-plan-details",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                },
                {
                  "name": "benefit",
                  "placeholder": "/Mo",
                  "inputTextAlignment": "right",
                  "title": "Benefit $"
                }
              ],
              "itemTitleWidth": "120px"
            }
          ]
        },
        {
          "type": "panel",
          "name": "forth-panel",
          "title": " ",
          "startWithNewLine": false,
          "elements": [
            {
              "type": "checkbox",
              "name": "options",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "emp-only",
                  "text": "LIFE AND AD&D (if offered)"
                },
                {
                  "value": "emp-sps",
                  "text": "Waive Coverage*"
                }
              ]
            },
            {
              "type": "checkbox",
              "name": "vol-life",
              "titleLocation": "hidden",
              "showCommentArea": true,
              "commentText": "",
              "choices": [
                {
                  "value": "Item 1",
                  "text": "VOL LIFE $"
                }
              ]
            },
            {
              "type": "checkbox",
              "name": "spouse",
              "titleLocation": "hidden",
              "showCommentArea": true,
              "commentText": "",
              "choices": [
                {
                  "value": "Item 1",
                  "text": "SPOUSE $"
                }
              ]
            },
            {
              "type": "checkbox",
              "name": "dependent-child",
              "titleLocation": "hidden",
              "showCommentArea": true,
              "commentText": "",
              "choices": [
                {
                  "value": "Item 1",
                  "text": "DEPENDENT CHILD $"
                }
              ]
            },
            {
              "type": "multipletext",
              "name": "carrier-forth-panel",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                }
              ],
              "itemTitleWidth": "120px"
            },
            {
              "type": "checkbox",
              "name": "forth-panel-options",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "Item 1",
                  "text": "STD (if offered)"
                },
                {
                  "value": "Item 2",
                  "text": "VOL. STD"
                },
                {
                  "value": "Item 3",
                  "text": "Waive Coverage*"
                },
                {
                  "value": "Item 4",
                  "text": "Waive Coverage*"
                }
              ],
              "colCount": 2
            },
            {
              "type": "multipletext",
              "name": "forth-panel-multi",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                },
                {
                  "name": "plan",
                  "title": "Plan #"
                },
                {
                  "name": "benefit",
                  "placeholder": "/Mo",
                  "inputTextAlignment": "right",
                  "title": "Benefit $"
                }
              ],
              "itemTitleWidth": "120px"
            }
          ]
        },
        {
          "type": "html",
          "name": "what-the-form-does",
          "html": "<p>\nThis form provides an option to make contributions for health insurance using pre-tax deductions, where applicable. By enrolling in a group health insurance plan, you acknowledge that eligible contributions may be deducted from your pay on a pre-tax basis, in accordance with applicable regulations. Pre-tax contributions may reduce taxable income, depending on individual circumstances. If you prefer not to use pre-tax deductions, please contact your HR representative or plan administrator.\n</p>"
        },
        {
          "type": "html",
          "name": "acknowledgment",
          "html": "<p>\nBy completing this form, you confirm that you have reviewed the available enrollment materials and understand the information provided. You also confirm that the selections made reflect your current choices.\n</p>\n"
        },
        {
          "type": "html",
          "name": "confirm-accuracy",
          "html": "<p>\nTo the best of your knowledge, the information provided in this form is accurate and complete. Providing incorrect or incomplete information may affect eligibility or participation in the selected plan(s).\n</p>"
        },
        {
          "type": "signaturepad",
          "name": "emp-signature",
          "title": "Employee's signature",
          "titleLocation": "top",
          "signatureHeight": 100
        },
        {
          "type": "text",
          "name": "emp-signature-date",
          "startWithNewLine": false,
          "title": "Date",
          "titleLocation": "top",
          "inputType": "date"
        },
        {
          "type": "signaturepad",
          "name": "hr-approval",
          "title": "HR approval",
          "titleLocation": "top",
          "signatureHeight": 100
        },
        {
          "type": "text",
          "name": "hr-approval-date",
          "startWithNewLine": false,
          "title": "Date",
          "titleLocation": "top",
          "inputType": "date"
        }
      ]
    }
  ],
  "headerView": "advanced"
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest",
    "survey-pdf": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/pdf-generator/examples/save-completed-forms-as-pdf-files/angular.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/save-completed-forms-as-pdf-files/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/save-completed-forms-as-pdf-files/jquery.md)
- [Vanilla JS](https://surveyjs.io/pdf-generator/examples/save-completed-forms-as-pdf-files/vanillajs.md)


---
title: Save Completed Forms to PDF
product: PDF Generator
description: See how to save a completed form as a PDF file using the SurveyJS PDF Generator library in your JavaScript app. You can archive your PDF forms in original format and easily access or share them once needed.
framework: Angular
source: https://surveyjs.io/pdf-generator/examples/save-completed-forms-as-pdf-files/angular
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Save Completed Forms to PDF (Angular)

SurveyJS PDF Generator is a client-side extension over SurveyJS Form Library that enables users to save surveys as PDF documents. This example shows how to save a filled-out form as a PDF document.

Start with creating a [`SurveyPDF`](/pdf-generator/documentation/api-reference/surveypdf) instance. A `SurveyPDF` constructor accepts a survey JSON schema and [PDF document configuration options](/pdf-generator/documentation/api-reference/idocoptions) as parameters:

```js
const surveyPdf = new SurveyPDF.SurveyPDF(surveyJson, pdfDocOptions);

// In modular applications:
import { SurveyPDF } from "survey-pdf";
const surveyPdf = new SurveyPDF(surveyJson, pdfDocOptions);
```

To generate a PDF document with given answers, assign a JSON object with survey results to `SurveyPDF`'s `data` property. Call the [`save(fileName)`](/pdf-generator/documentation/api-reference/surveypdf#save) method to save the generated form on the user's computer:

```js
surveyPdf.data = surveyResults;
surveyPdf.save("My Survey.pdf");
```

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "title": "Employee Health Insurance Enrollment Form",
  "description": "Please note that completing this form does not guarantee coverage.",
  "pages": [
    {
      "name": "employee-health-insurance-enrollment-form",
      "elements": [
        {
          "type": "panel",
          "name": "contact-details-panel",
          "title": "Contact Details",
          "elements": [
            {
              "type": "text",
              "name": "name",
              "title": "Name"
            },
            {
              "type": "text",
              "name": "ssn",
              "startWithNewLine": false,
              "title": "SSN",
              "width": "30%",
              "maskType": "pattern",
              "maskSettings": {
                "pattern": "999-99-9999"
              }
            },
            {
              "type": "text",
              "name": "address",
              "title": "Address"
            },
            {
              "type": "text",
              "name": "dob",
              "width": "30%",
              "startWithNewLine": false,
              "title": "Date of Birth",
              "inputType": "date",
              "maskType": "datetime",
              "maskSettings": {
                "pattern": "mm/dd/yyyy"
              }
            },
            {
              "type": "text",
              "name": "city",
              "title": "City"
            },
            {
              "type": "text",
              "name": "state",
              "startWithNewLine": false,
              "title": "State"
            },
            {
              "type": "text",
              "name": "zip-code",
              "startWithNewLine": false,
              "title": "Zip Code",
              "width": "30%",
              "maskType": "pattern",
              "maskSettings": {
                "pattern": "99999"
              }
            },
            {
              "type": "text",
              "name": "phone-number",
              "title": "Phone Number",
              "maskType": "pattern",
              "maskSettings": {
                "pattern": "999 999-9999"
              }
            },
            {
              "type": "text",
              "name": "email",
              "startWithNewLine": false,
              "title": "E-Mail ",
              "inputType": "email",
              "placeholder": "name@example.com"
            },
            {
              "type": "radiogroup",
              "name": "sex",
              "width": "30%",
              "startWithNewLine": false,
              "title": "Sex",
              "choices": [
                {
                  "value": "male",
                  "text": "Male"
                },
                "Female"
              ],
              "colCount": 2
            },
            {
              "type": "dropdown",
              "name": "marital-status",
              "title": "Marital Status",
              "choices": [
                {
                  "value": "single",
                  "text": "Single"
                },
                {
                  "value": "married",
                  "text": "Married"
                },
                {
                  "value": "divorced",
                  "text": "Divorced"
                },
                {
                  "value": "separated",
                  "text": "Separated"
                },
                {
                  "value": "widowed",
                  "text": "Widowed"
                }
              ]
            },
            {
              "type": "text",
              "name": "date-of-marriage",
              "startWithNewLine": false,
              "title": "Date of Marriage",
              "description": "Only if 'Married' is selected.",
              "descriptionLocation": "underInput",
              "inputType": "date",
              "maskType": "datetime",
              "maskSettings": {
                "pattern": "mm/dd/yyyy"
              }
            }
          ]
        },
        {
          "type": "panel",
          "name": "work-details",
          "title": "Work Information",
          "elements": [
            {
              "type": "text",
              "name": "employer",
              "title": "Employer"
            },
            {
              "type": "text",
              "name": "job-title",
              "startWithNewLine": false,
              "title": "Job Title"
            },
            {
              "type": "text",
              "name": "date-of-hire",
              "width": "30%",
              "startWithNewLine": false,
              "title": "Date of Hire",
              "inputType": "date"
            }
          ]
        },
        {
          "type": "panel",
          "name": "other-insurance-panel",
          "title": "Other Insurance Information",
          "elements": [
            {
              "type": "boolean",
              "name": "other-insurance",
              "title": "Does anyone in your family have other insurance?",
              "descriptionLocation": "underInput"
            },
            {
              "type": "dropdown",
              "name": "who-through",
              "startWithNewLine": false,
              "title": "If yes, who is the coverage through?",
              "choices": [
                {
                  "value": "self",
                  "text": "Self"
                },
                {
                  "value": "spouse",
                  "text": "Spouse"
                },
                {
                  "value": "parent",
                  "text": "Parent"
                }
              ]
            },
            {
              "type": "text",
              "width": "30%",
              "name": "date-of-coverage",
              "startWithNewLine": false,
              "title": "Effective Date of Coverage:",
              "inputType": "date"
            },
            {
              "type": "text",
              "name": "carrier",
              "title": "Carrier:"
            },
            {
              "type": "text",
              "name": "policy-number",
              "startWithNewLine": false,
              "title": "Policy #: "
            },
            {
              "type": "boolean",
              "name": "are-you-covered-by-medicare",
              "title": "Are you covered by Medicare?"
            },
            {
              "type": "text",
              "name": "medicate-number",
              "startWithNewLine": false,
              "title": "Medicare #"
            },
            {
              "type": "text",
              "name": "medicare-date-part-A",
              "title": "Effective Date (Part A):",
              "inputType": "date"
            },
            {
              "type": "text",
              "name": "medicate-date-part-B",
              "startWithNewLine": false,
              "title": "Effective Date (Part B):",
              "inputType": "date"
            },
            {
              "type": "boolean",
              "name": "spouse-dependents-medicare",
              "title": "Is your spouse or dependent(s) covered by Medicare?"
            },
            {
              "type": "text",
              "name": "medicare-spouse",
              "startWithNewLine": false,
              "title": "Medicare #"
            },
            {
              "type": "text",
              "name": "medicare-dependents-date-part-A",
              "title": "Effective Date (Part A):",
              "inputType": "date"
            },
            {
              "type": "text",
              "name": "medicare-dependents-date-part-B",
              "startWithNewLine": false,
              "title": "Effective Date (Part B):",
              "inputType": "date"
            }
          ]
        },
        {
          "type": "panel",
          "name": "health-insurance-panel",
          "title": "Persons Covered ",
          "description": "Only your Legal Spouse and unmarried natural, adopted or stepchildren who meet the dependent requirements are eligible for coverage.",
          "elements": [
            {
              "type": "matrixdropdown",
              "name": "persons-covered",
              "title": "Persons Covered: ",
              "titleLocation": "hidden",
              "description": "Only your Legal Spouse and unmarried natural, adopted or stepchildren who meet the dependent requirements are eligible for coverage.",
              "alternateRows": true,
              "columns": [
                {
                  "name": "coverage",
                  "title": "Coverage",
                  "cellType": "checkbox",
                  "minWidth": "110px",
                  "choices": [
                    {
                      "value": "add",
                      "text": "Add"
                    },
                    {
                      "value": "remove",
                      "text": "Remove"
                    }
                  ]
                },
                {
                  "name": "first-name",
                  "title": "First Name",
                  "cellType": "text"
                },
                {
                  "name": "surname",
                  "title": "Surname",
                  "cellType": "text"
                },
                {
                  "name": "date-of-birth",
                  "title": "Date of Birth",
                  "cellType": "text",
                  "minWidth": "110px",
                  "inputType": "date"
                },
                {
                  "name": "ssn",
                  "title": "SSN",
                  "cellType": "text",
                  "maskType": "pattern",
                  "maskSettings": {
                    "pattern": "999-99-9999"
                  }
                },
                {
                  "name": "sex",
                  "title": "Sex",
                  "cellType": "dropdown",
                  "choices": [
                    {
                      "value": "male",
                      "text": "Male"
                    },
                    {
                      "value": "female",
                      "text": "Female"
                    }
                  ]
                }
              ],
              "choices": [
                1,
                2,
                3,
                4,
                5
              ],
              "rows": [
                {
                  "value": "employer",
                  "text": "Employer"
                },
                {
                  "value": "spouse",
                  "text": "Spouse"
                },
                {
                  "value": "chd1",
                  "text": "Child #1"
                },
                {
                  "value": "chd2",
                  "text": "Child #2"
                },
                {
                  "value": "chd3",
                  "text": "Child #3"
                },
                {
                  "value": "chd4",
                  "text": "Child #4"
                },
                {
                  "value": "chd5",
                  "text": "Child #5"
                },
                {
                  "value": "chd6",
                  "text": "Child #6"
                }
              ],
              "rowTitleWidth": "90px"
            }
          ]
        },
        {
          "type": "panel",
          "name": "medical-plan-panel",
          "title": "Medical Plan",
          "elements": [
            {
              "type": "multipletext",
              "name": "medical-multi",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                },
                {
                  "name": "plan-type",
                  "title": "Plan Type"
                },
                {
                  "name": "carrier-group",
                  "title": "Carrier Group #"
                }
              ],
              "itemTitleWidth": "120px"
            },
            {
              "type": "checkbox",
              "name": "medical-plan-coverage",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "emp-only",
                  "text": "Employee Only"
                },
                {
                  "value": "emp-sps",
                  "text": "Employee & Spouse"
                },
                {
                  "value": "emp-chl",
                  "text": "Employee / Child(ren)"
                },
                {
                  "value": "fam",
                  "text": "Family"
                },
                {
                  "value": "over-sixty-five",
                  "text": "Over 65",
                  "isCommentRequired": true,
                  "commentPlaceholder": "retired/working"
                },
                {
                  "value": "med-comp",
                  "text": "Medicare or Complimentary to Medicare (CareFirst-Individual only; and benefit coverage only. Not eligible for HSA)"
                },
                {
                  "value": "waive-coverage",
                  "text": "Waive Coverage*"
                }
              ]
            }
          ]
        },
        {
          "type": "panel",
          "name": "dental-plan-panel",
          "title": "Dental Plan",
          "startWithNewLine": false,
          "elements": [
            {
              "type": "multipletext",
              "name": "dental-multi",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                },
                {
                  "name": "plan-type",
                  "title": "Plan Type"
                },
                {
                  "name": "carrier-group",
                  "title": "Carrier Group #"
                }
              ],
              "itemTitleWidth": "120px"
            },
            {
              "type": "checkbox",
              "name": "dental-plan-coverage",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "emp-only",
                  "text": "Employee Only"
                },
                {
                  "value": "emp-sps",
                  "text": "Employee & Spouse"
                },
                {
                  "value": "emp-chl",
                  "text": "Employee / Child(ren)"
                },
                {
                  "value": "fam",
                  "text": "Family"
                },
                {
                  "value": "over-sixty-five",
                  "text": "Over 65",
                  "isCommentRequired": true,
                  "commentPlaceholder": "retired/working"
                },
                {
                  "value": "waive-coverage",
                  "text": "Waive Coverage*"
                }
              ]
            },
            {
              "type": "multipletext",
              "name": "dental-plan-details",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Provider # "
                },
                {
                  "name": "plan-type",
                  "title": "Name"
                },
                {
                  "name": "carrier-group",
                  "title": "Family Dentist"
                },
                {
                  "name": "name",
                  "title": "Name"
                },
                {
                  "name": "office",
                  "title": "Office #"
                }
              ],
              "itemTitleWidth": "120px"
            }
          ]
        },
        {
          "type": "panel",
          "name": "vision-plan-panel",
          "title": "Vision Plan",
          "elements": [
            {
              "type": "multipletext",
              "name": "vision-plan-multi",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                },
                {
                  "name": "carrier-group",
                  "title": "Carrier Group #"
                }
              ],
              "itemTitleWidth": "120px"
            },
            {
              "type": "checkbox",
              "name": "vision-plan-coverage",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "emp-only",
                  "text": "Employee Only"
                },
                {
                  "value": "emp-sps",
                  "text": "Employee & Spouse"
                },
                {
                  "value": "emp-chl",
                  "text": "Employee / Child(ren)"
                },
                {
                  "value": "fam",
                  "text": "Family"
                },
                {
                  "value": "over-sixty-five",
                  "text": "Over 65",
                  "isCommentRequired": true,
                  "commentPlaceholder": "retired/working"
                },
                {
                  "value": "waive-coverage",
                  "text": "Waive Coverage*"
                }
              ]
            },
            {
              "type": "checkbox",
              "name": "vision-plan-options",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "Item 1",
                  "text": "LTD (if offered)"
                },
                {
                  "value": "Item 2",
                  "text": "VOL. LTD"
                },
                {
                  "value": "Item 3",
                  "text": "Waive Coverage*"
                },
                {
                  "value": "Item 4",
                  "text": "Waive Coverage*"
                }
              ],
              "colCount": 2
            },
            {
              "type": "multipletext",
              "name": "vision-plan-details",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                },
                {
                  "name": "benefit",
                  "placeholder": "/Mo",
                  "inputTextAlignment": "right",
                  "title": "Benefit $"
                }
              ],
              "itemTitleWidth": "120px"
            }
          ]
        },
        {
          "type": "panel",
          "name": "forth-panel",
          "title": " ",
          "startWithNewLine": false,
          "elements": [
            {
              "type": "checkbox",
              "name": "options",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "emp-only",
                  "text": "LIFE AND AD&D (if offered)"
                },
                {
                  "value": "emp-sps",
                  "text": "Waive Coverage*"
                }
              ]
            },
            {
              "type": "checkbox",
              "name": "vol-life",
              "titleLocation": "hidden",
              "showCommentArea": true,
              "commentText": "",
              "choices": [
                {
                  "value": "Item 1",
                  "text": "VOL LIFE $"
                }
              ]
            },
            {
              "type": "checkbox",
              "name": "spouse",
              "titleLocation": "hidden",
              "showCommentArea": true,
              "commentText": "",
              "choices": [
                {
                  "value": "Item 1",
                  "text": "SPOUSE $"
                }
              ]
            },
            {
              "type": "checkbox",
              "name": "dependent-child",
              "titleLocation": "hidden",
              "showCommentArea": true,
              "commentText": "",
              "choices": [
                {
                  "value": "Item 1",
                  "text": "DEPENDENT CHILD $"
                }
              ]
            },
            {
              "type": "multipletext",
              "name": "carrier-forth-panel",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                }
              ],
              "itemTitleWidth": "120px"
            },
            {
              "type": "checkbox",
              "name": "forth-panel-options",
              "titleLocation": "hidden",
              "choices": [
                {
                  "value": "Item 1",
                  "text": "STD (if offered)"
                },
                {
                  "value": "Item 2",
                  "text": "VOL. STD"
                },
                {
                  "value": "Item 3",
                  "text": "Waive Coverage*"
                },
                {
                  "value": "Item 4",
                  "text": "Waive Coverage*"
                }
              ],
              "colCount": 2
            },
            {
              "type": "multipletext",
              "name": "forth-panel-multi",
              "titleLocation": "hidden",
              "items": [
                {
                  "name": "carrier",
                  "title": "Carrier"
                },
                {
                  "name": "plan",
                  "title": "Plan #"
                },
                {
                  "name": "benefit",
                  "placeholder": "/Mo",
                  "inputTextAlignment": "right",
                  "title": "Benefit $"
                }
              ],
              "itemTitleWidth": "120px"
            }
          ]
        },
        {
          "type": "html",
          "name": "what-the-form-does",
          "html": "<p>\nThis form provides an option to make contributions for health insurance using pre-tax deductions, where applicable. By enrolling in a group health insurance plan, you acknowledge that eligible contributions may be deducted from your pay on a pre-tax basis, in accordance with applicable regulations. Pre-tax contributions may reduce taxable income, depending on individual circumstances. If you prefer not to use pre-tax deductions, please contact your HR representative or plan administrator.\n</p>"
        },
        {
          "type": "html",
          "name": "acknowledgment",
          "html": "<p>\nBy completing this form, you confirm that you have reviewed the available enrollment materials and understand the information provided. You also confirm that the selections made reflect your current choices.\n</p>\n"
        },
        {
          "type": "html",
          "name": "confirm-accuracy",
          "html": "<p>\nTo the best of your knowledge, the information provided in this form is accurate and complete. Providing incorrect or incomplete information may affect eligibility or participation in the selected plan(s).\n</p>"
        },
        {
          "type": "signaturepad",
          "name": "emp-signature",
          "title": "Employee's signature",
          "titleLocation": "top",
          "signatureHeight": 100
        },
        {
          "type": "text",
          "name": "emp-signature-date",
          "startWithNewLine": false,
          "title": "Date",
          "titleLocation": "top",
          "inputType": "date"
        },
        {
          "type": "signaturepad",
          "name": "hr-approval",
          "title": "HR approval",
          "titleLocation": "top",
          "signatureHeight": 100
        },
        {
          "type": "text",
          "name": "hr-approval-date",
          "startWithNewLine": false,
          "title": "Date",
          "titleLocation": "top",
          "inputType": "date"
        }
      ]
    }
  ],
  "headerView": "advanced"
};
```

### `src/app/components/pdf.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/pdf.component.html`

```html
<survey [model]="model"></survey>
```

### `src/app/components/pdf.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { SurveyPDF } from "survey-pdf";
import { json } from "./json";
import "./pdf.component.css";
import "survey-core/survey-core.min.css";

function createSurveyPdfModel (surveyModel) {
    const options = {
        otherRowsCount: 1
    };
    const surveyPDF = new SurveyPDF(json, options);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    surveyPDF.onGetPanelStyle.add((_, options) => {
        const compactPanels = [
            "medical-plan-panel",
            "dental-plan-panel",
            "forth-panel",
            "vision-plan-panel"
        ];

        if (compactPanels.includes(options.panel.name)) {
            options.style.minWidth = 0;
        }
    });

    surveyPDF.onGetQuestionStyle.add((_, options) => {
        if (
            options.question.name === "sex" ||
            options.question.name === "persons-covered"
        ) {
            options.style.columnMinWidth = 20;
        }
    });
    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./pdf.component.html",
    styleUrls: ["./pdf.component.css"]
})
export class SurveyPdfComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.showCompleteButton = false;
        survey.navigationButtonsLocation = "topBottom";
        survey.addNavigationItem({
            id: "survey_save_as_file",
            title: "Download PDF",
            action: () => {
                saveSurveyToPdf("surveyResult.pdf", survey);
            }
        });
        survey.addNavigationItem({
            id: "survey_pdf_preview",
            title: "Preview PDF",
            visible: window.navigator.pdfViewerEnabled,
            action: () => {
                previewPdf(survey);
            }
        });
        survey.data = {
          "name": "Jane Doe",
          "ssn": "123-45-6789",
          "address": "742 Evergreen Terrace",
          "dob": "1985-03-15",
          "city": "Springfield",
          "state": "IL",
          "zip-code": "62704",
          "phone-number": "217 555-0142",
          "email": "jane.doe@example.com",
          "sex": "Female",
          "marital-status": "married",
          "date-of-marriage": "2012-06-08",
          "employer": "Acme Corporation",
          "job-title": "Senior Analyst",
          "date-of-hire": "2018-09-04",
          "other-insurance": true,
          "who-through": "spouse",
          "date-of-coverage": "2024-01-01",
          "carrier": "Blue Cross Blue Shield",
          "policy-number": "BC-8847291",
          "are-you-covered-by-medicare": false,
          "spouse-dependents-medicare": false,
          "persons-covered": {
             "employer": {
                "coverage": [
                   "add"
                ],
                "first-name": "Jane",
                "surname": "Doe",
                "date-of-birth": "1985-03-15",
                "ssn": "123-45-6789",
                "sex": "female"
             },
             "spouse": {
                "coverage": [
                   "add"
                ],
                "first-name": "John",
                "surname": "Doe",
                "date-of-birth": "1983-11-22",
                "ssn": "987-65-4321",
                "sex": "male"
             },
             "chd1": {
                "coverage": [
                   "add"
                ],
                "first-name": "Emily",
                "surname": "Doe",
                "date-of-birth": "2015-04-10",
                "ssn": "456-78-9012",
                "sex": "female"
             }
          },
          "medical-multi": {
             "carrier": "CareFirst",
             "plan-type": "PPO",
             "carrier-group": "GRP-10294"
          },
          "medical-plan-coverage": [
             "fam"
          ],
          "dental-multi": {
             "carrier": "Delta Dental",
             "plan-type": "Premium",
             "carrier-group": "DD-55821"
          },
          "dental-plan-coverage": [
             "fam"
          ],
          "dental-plan-details": {
             "carrier": "DL-9021",
             "plan-type": "Dr. Sarah Mitchell",
             "carrier-group": "Yes",
             "name": "Dr. Sarah Mitchell",
             "office": "Springfield Family Dental"
          },
          "vision-plan-multi": {
             "carrier": "VSP",
             "carrier-group": "VSP-44102"
          },
          "vision-plan-coverage": [
             "fam"
          ],
          "vision-plan-options": [
             "Item 1"
          ],
          "vision-plan-details": {
             "carrier": "MetLife",
             "benefit": "250"
          },
          "options": [
             "emp-only"
          ],
          "vol-life": [
             "Item 1"
          ],
          "vol-life-Comment": "100000",
          "spouse": [
             "Item 1"
          ],
          "spouse-Comment": "50000",
          "dependent-child": [
             "Item 1"
          ],
          "dependent-child-Comment": "10000",
          "carrier-forth-panel": {
             "carrier": "Guardian"
          },
          "forth-panel-options": [
             "Item 1"
          ],
          "forth-panel-multi": {
             "carrier": "Guardian",
             "plan": "STD-204",
             "benefit": "1200"
          },
          "emp-signature-date": "2026-05-27",
          "hr-approval-date": "2026-05-28"
        }
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyPdfComponent } from "./components/pdf.component";

@NgModule({
    declarations: [AppComponent, SurveyPdfComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;">
        <app-root></app-root>
    </div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css

```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "survey-pdf": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/pdf-generator/examples/save-completed-forms-as-pdf-files/reactjs.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/save-completed-forms-as-pdf-files/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/save-completed-forms-as-pdf-files/jquery.md)
- [Vanilla JS](https://surveyjs.io/pdf-generator/examples/save-completed-forms-as-pdf-files/vanillajs.md)
